/* Includes ------------------------------------------------------------------*/
#include "DEV_Config.h"
#include "EPD.h"
#include "GUI_Paint.h"
#include "imagedata.h"
#include <stdlib.h>
#include <SPIFFS.h>
#define DEBG


char getplate(){
  char buf[4];
  size_t s;
  File f = SPIFFS.open("/plate.txt", "r");
  s=f.readBytes(buf,1);
  f.close();
  buf[1]=0;
  prtf("Buffer:");
  prtf(buf);
  buf[0]=(buf[0]=='0')?'1':((buf[0]=='1')?'2':'0');
  f = SPIFFS.open("/plate.txt", "w");
  f.write(buf[0]);
  f.close();
  return((char)buf[0]);}

void prtf(const char * s){
  char c;
  #ifdef DEBG
  printf(s);
  #endif
  }
/* Entry point ----------------------------------------------------------------*/
void setup()
{
  SPIFFS.begin(true);
  prtf("Plate start\r\n");
  DEV_Module_Init();
  EPD_7IN5BC_Init();
  while(!SPIFFS.begin(true)){
    prtf("An error has occurred while mounting SPIFFS");
    delay(100);}

  //Create a new image cache named IMAGE_BW and fill it with white
  UBYTE *BlackImage;
  UWORD Imagesize = ((EPD_7IN5BC_WIDTH % 8 == 0) ? (EPD_7IN5BC_WIDTH / 8 ) : (EPD_7IN5BC_WIDTH / 8)) * EPD_7IN5BC_HEIGHT;
  if ((BlackImage = (UBYTE *)malloc(Imagesize)) == NULL) {
    prtf("Failed to apply for black memory...\r\n");
    while(1);
  }
  Paint_NewImage(BlackImage, EPD_7IN5BC_WIDTH, EPD_7IN5BC_HEIGHT, 0, WHITE);
  Paint_SelectImage(BlackImage);
  Paint_Clear(WHITE);
  char c=getplate();
  EPD_7IN5BC_Display(c=='0'?plate0:(c=='1'?plate1:plate2), BlackImage);
  prtf("Finished");

  // Go to sleep
  EPD_7IN5BC_Sleep();
  esp_deep_sleep_start();
}

/* The main loop -------------------------------------------------------------*/
void loop()
{
  //
}
